<?php
/***************************************************************************

	BEER MOD v.2.0

	Date:		2006-12-04 23:28
	Author: 		qbs (c) 2006
	Website:		http://ixdude.com
	Support:		http://mody.lastinn.info

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

// create arrays for mode posibilities
$mode_options = array('index', 'synchronize', 'user_got', 'user_gave', 'post_beer', 'remove_beer', 'remove_posted_beers', 'remove_collected_beers', 'post_details', 'topic_details');
$mode_options_logged = array('synchronize', 'post_beer', 'remove_beer', 'remove_posted_beers', 'remove_collected_beers');
$mode_options_admin = array('synchronize', 'remove_beer', 'remove_posted_beers', 'remove_collected_beers');

// assign http variables to php
$beer_id = intval(($HTTP_GET_VARS['b']) ? $HTTP_GET_VARS['b'] : $HTTP_POST_VARS['b']);
$topic_id = intval(($HTTP_GET_VARS[POST_TOPIC_URL]) ? $HTTP_GET_VARS[POST_TOPIC_URL] : $HTTP_POST_VARS[POST_TOPIC_URL]);
$post_id = intval(($HTTP_GET_VARS[POST_POST_URL]) ? $HTTP_GET_VARS[POST_POST_URL] : $HTTP_POST_VARS[POST_POST_URL]);
$user_id = intval(($HTTP_GET_VARS[POST_USERS_URL]) ? $HTTP_GET_VARS[POST_USERS_URL] : $HTTP_POST_VARS[POST_USERS_URL]);
$mode = ($HTTP_GET_VARS['mode']) ? $HTTP_GET_VARS['mode'] : $HTTP_POST_VARS['mode'];
$mode = (@in_array($mode, $mode_options)) ? $mode : $mode_options[0];
$confirm = (isset($HTTP_POST_VARS['confirm'])) ? true : false;
$ref_url = base64_decode($HTTP_POST_VARS['ref_url']);
$time = time();

// create userdata
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

// assign most used userdata to simple variables for more simplicity
$userdata_user_id = intval($userdata['user_id']);
$userdata_user_level = intval($userdata['user_level']);

// checking is user logged, verifying requested mode
if ( $userdata_user_id < 2 && in_array($mode, $mode_options_logged) )
{
	message_die(GENERAL_ERROR, $lang['login_require']);
}

// checking is user an admin, verifying requested mode
if ( $userdata_user_level != ADMIN && in_array($mode, $mode_options_admin) )
{
	message_die(GENERAL_ERROR, $lang['Not_Authorised']);
}

$beermod->init(__FILE__);
$lang = array_merge($lang, $beermod->lang);

if ( !$beermod->config['enabled'] )
{
	message_die(GENERAL_ERROR, $lang['Beermod_disabled']);
}

switch ( $mode )
{
	case 'remove_beer':
		if ( !$beer_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_beer_id']);
		}
		if ( !$post_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_post_id']);
		}
		if ( isset($HTTP_POST_VARS['cancel']) )
		{
			redirect( ( strpos($ref_url, $_SERVER['HTTP_HOST']) ) ? basename($ref_url) : append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id") . "#$post_id" );
		}
		if ( !$confirm )
		{
			$message = '</span><form action="' . append_sid("beermod.$phpEx?mode=remove_beer&amp;b=$beer_id&amp;" . POST_POST_URL . "=$post_id") . '" method="post">' . $lang['Beermod_confirm_remove_beer_text'] . '<br /><br /><input type="submit" name="confirm" value="' . $lang['Yes'] . '" class="mainoption" /> &nbsp; <input type="submit" name="cancel" value="' . $lang['Cancel'] . '" class="liteoption" /><input type="hidden" name="ref_url" value="' . str_replace('=', '', base64_encode($_SERVER['HTTP_REFERER'])) . '" /></form><span class="gen">';
			message_die(GENERAL_MESSAGE, $message, $lang['Beermod_confirmation_required']);
		}
		if ( $beermod->remove_beer($db, $beer_id) )
		{
			redirect( append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id") . "#$post_id" );
		}
		break;
		
 	case 'remove_collected_beers':
		if ( !$user_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_user_id']);
		}
		if ( isset($HTTP_POST_VARS['cancel']) )
		{
			redirect( ( strpos($ref_url, $_SERVER['HTTP_HOST']) ) ? basename($ref_url) : append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id") );
		}
		if ( !$confirm )
		{
			$message = '</span><form action="' . append_sid("beermod.$phpEx?mode=remove_collected_beers&amp;" . POST_USERS_URL . "=$user_id") . '" method="post">' . $lang['Beermod_confirm_remove_collected_beers_text'] . '<br /><br /><input type="submit" name="confirm" value="' . $lang['Yes'] . '" class="mainoption" /> &nbsp; <input type="submit" name="cancel" value="' . $lang['Cancel'] . '" class="liteoption" /><input type="hidden" name="ref_url" value="' . str_replace('=', '', base64_encode($_SERVER['HTTP_REFERER'])) . '" /></form><span class="gen">';
			message_die(GENERAL_MESSAGE, $message, $lang['Beermod_confirmation_required']);
		}
		if ( $beermod->remove_collected_beers($db, $user_id) )
		{
			redirect( append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id") );
		}
		break;
		
 	case 'remove_posted_beers':
		if ( !$user_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_user_id']);
		}
		if ( isset($HTTP_POST_VARS['cancel']) )
		{
			redirect( ( strpos($ref_url, $_SERVER['HTTP_HOST']) ) ? basename($ref_url) : append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id") );
		}
		if ( !$confirm )
		{
			$message = '</span><form action="' . append_sid("beermod.$phpEx?mode=remove_posted_beers&amp;" . POST_USERS_URL . "=$user_id") . '" method="post">' . $lang['Beermod_confirm_remove_posted_beers_text'] . '<br /><br /><input type="submit" name="confirm" value="' . $lang['Yes'] . '" class="mainoption" /> &nbsp; <input type="submit" name="cancel" value="' . $lang['Cancel'] . '" class="liteoption" /><input type="hidden" name="ref_url" value="' . str_replace('=', '', base64_encode($_SERVER['HTTP_REFERER'])) . '" /></form><span class="gen">';
			message_die(GENERAL_MESSAGE, $message, $lang['Beermod_confirmation_required']);
		}
		if ( $beermod->remove_posted_beers($db, $user_id) )
		{
			redirect( append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id") );
		}
		break;

	case 'post_beer':
		if ( !$post_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_post_id']);
		}
		if ( isset($HTTP_POST_VARS['cancel']) )
		{
			redirect( ( strpos($ref_url, $_SERVER['HTTP_HOST']) ) ? basename($ref_url) : append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id") . "#$post_id" );
		}
		if ( !$confirm )
		{
			$message = '</span><form action="' . append_sid("beermod.$phpEx?mode=post_beer&amp;" . POST_POST_URL . "=$post_id") . '" method="post">' . $lang['Beermod_confirm_text'] . '<br /><br /><input type="submit" name="confirm" value="' . $lang['Yes'] . '" class="mainoption" /> &nbsp; <input type="submit" name="cancel" value="' . $lang['Cancel'] . '" class="liteoption" /><input type="hidden" name="ref_url" value="' . str_replace('=', '', base64_encode($_SERVER['HTTP_REFERER'])) . '" /></form><span class="gen">';
			message_die(GENERAL_MESSAGE, $message, $lang['Beermod_confirmation_required']);
		}
		if ( $beermod->submit_beer($db, $post_id, $userdata_user_id) )
		{
			redirect( ( strpos($ref_url, $_SERVER['HTTP_HOST']) ) ? basename($ref_url) : append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id") . "#$post_id" );
		}
		break;

	case 'synchronize':
		if ( $beermod->synchronize() )
		{
			if ( strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) )
				header('Location: ' . $_SERVER['HTTP_REFERER']);
			message_die(GENERAL_MESSAGE, 'Beers has been synchronized.');
		}
		break;

	case 'topic_details':
		if ( !$topic_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_topic_id']);
		}
		$beer_data = $beermod->get_topic_beers($topic_id);
		$page_body = 'beermod_topic_details_body.tpl';

		$sql = "select topic_id, topic_title from " . TOPICS_TABLE . " where topic_id = $topic_id limit 1";
		$results = $db->sql_query($sql);
		$_data = $db->sql_fetchrow($results);

		$_page_title = sprintf($lang['Beermod_topic_details'], append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id"), $_data['topic_title']);
		break;

	case 'post_details':
		if ( !$post_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_post_id']);
		}
		$beer_data = $beermod->get_post_beers($post_id);
		$page_body = 'beermod_post_details_body.tpl';

		$_page_title = sprintf($lang['Beermod_post_details'], append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id") . "#$post_id", "#$post_id");

		break;

	case 'user_got':
		if ( !$user_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_user_id']);
		}
		$beer_data = $beermod->get_user_beers($user_id);
		$page_body = 'beermod_user_details_body.tpl';

		$sql = "select user_id, username from " . USERS_TABLE . " where user_id = $user_id limit 1";
		$results = $db->sql_query($sql);
		$_data = $db->sql_fetchrow($results);

		$_page_title = sprintf($lang['Beermod_user_details'], append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id"), $_data['username']);

		break;

	case 'user_gave':
		if ( !$user_id )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_user_id']);
		}
		$beer_data = $beermod->get_poster_beers($user_id);
		$page_body = 'beermod_user_details_body.tpl';

		$sql = "select user_id, username from " . USERS_TABLE . " where user_id = $user_id";
		$results = $db->sql_query($sql);
		$_data = $db->sql_fetchrow($results);

		$_page_title = sprintf($lang['Beermod_poster_details'], append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id"), $_data['username']);

		break;

	default:
		$beer_data_users = $beermod->get_user_toplist($user_id);
		$beer_data_posters = $beermod->get_poster_toplist($user_id);
		$page_body = 'beermod_toplist_body.tpl';

		$_page_title = $lang['Beermod_toplist'];
}
$page_title = strip_tags($_page_title);
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$remove_url = '';
$remove_url = ($userdata['user_level'] == ADMIN && $mode == 'user_got') ? sprintf($lang['Beermod_remove_collected_beers'], append_sid("beermod.$phpEx?mode=remove_collected_beers&amp;u=$user_id")) : $remove_url;
$remove_url = ($userdata['user_level'] == ADMIN && $mode == 'user_gave') ? sprintf($lang['Beermod_remove_posted_beers'], append_sid("beermod.$phpEx?mode=remove_posted_beers&amp;u=$user_id")) : $remove_url;

$switch_url = '';
$switch_url = ($userdata['user_level'] == ADMIN && $mode == 'user_got') ? sprintf($lang['Beermod_switch_posted_beers'], append_sid("beermod.$phpEx?mode=user_gave&amp;u=$user_id")) : $switch_url;
$switch_url = ($userdata['user_level'] == ADMIN && $mode == 'user_gave') ? sprintf($lang['Beermod_switch_collected_beers'], append_sid("beermod.$phpEx?mode=user_got&amp;u=$user_id")) : $switch_url;

$template->set_filenames(array('body' => $page_body));
$template->assign_vars(array(
	'PAGE_TITLE' => $_page_title,
	'L_NUMBER' => ($userdata['user_level'] == ADMIN && $mode == 'post_details') ? $lang['Beermod_remove'] : $lang['Beermod_number'],
	'L_TOPIC' => $lang['Topic'],
	'L_LC_TOPIC' => strtolower($lang['Topic']),
	'L_POST' => $lang['Post'],
	'L_LC_POST' => strtolower($lang['Post']),
	'L_COUNT' => $lang['Beermod_count'],
	'L_USER' => $lang['Username'],
	'L_BAR' => $lang['Beermod_bar'],
	'L_TOPLIST_USERS' => $lang['Beermod_toplist_users'],
	'L_TOPLIST_POSTERS' => $lang['Beermod_toplist_posters'],
	'REMOVE_BEERS' => $remove_url,
	'SWITCH_BEERS' => $switch_url,
	'TOPLIST_URL' => sprintf($lang['Beermod_toplist_index'], append_sid("beermod.$phpEx")),
	));

switch ($mode)
{
	case 'user_gave':
	case 'user_got':
		$count = 0;
		foreach( $beer_data as $row )
		{
			if ( !$row['beer_count'] )
			{
				continue;
			}
			$count++;
			$template->assign_block_vars('beersrow', array(
				'ROW_CLASS' => ($count%2) ? 'row1' : 'row2',
				'NO' => intval($count),
				'TOPIC_TITLE' => '<a href="' . append_sid("beermod.$phpEx?mode=topic_details&amp;" . POST_TOPIC_URL . "=" . $row['topic_id']) . '" class="topictitle">' . $row['topic_title'] . '</a>',
				'TOPIC_LINK' => '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $row['topic_id']) . '">' . $lang['Beermod_follow'] . '</a>',
				'BEERS_COUNT' => $row['beer_count'],
				'PERCENTAGE_BAR' => round($row['beer_count'] / $beer_data['total_beer_count'],2) * 100,
				));
		}
		break;

	case 'post_details':
		$count = 0;
		foreach( $beer_data as $row )
		{
			if ( !$row['beer_id'] )
			{
				continue;
			}
			$count++;
			$colors = color_username($row['user_level'], $row['user_jr'], $row['user_id'], $row['username'], true, 'text-decoration:none');
			$template->assign_block_vars('beersrow', array(
				'ROW_CLASS' => ($count%2) ? 'row1' : 'row2',
				'NO' => ($userdata['user_level'] == ADMIN) ? '<a href="' . append_sid("beermod.$phpEx?mode=remove_beer&b=" . $row['beer_id'] . "&amp;" . POST_POST_URL . "=$post_id") . '"><img src="' . $images['icon_delpost'] . '" alt="" title="' . $lang['Beermod_remove'] . '" border="0" /></a>' : intval($count),
				'TOPIC_TITLE' => '<a href="' . append_sid("beermod.$phpEx?mode=topic_details&amp;" . POST_TOPIC_URL . "=" . $row['topic_id']) . '" class="topictitle">' . $row['topic_title'] . '</a>',
				'TOPIC_LINK' => '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $row['topic_id']) . '">' . $lang['Beermod_follow'] . '</a>',
				'BEERS_DST' => '<a href="' . append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '">' . $row['user_beers_src'] . '</a>',
				'BEERS_SRC' => '<a href="' . append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '">' . intval($row['user_beers_dst']) . '</a>',
				'PERCENTAGE_BAR' => round($row['user_beers_src'] / $beer_data['total_src'],2) * 100,
				'POST_LINK' => '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . "#$post_id" . '" class="topictitle">#' . $post_id . '</a>',
				'USERNAME' => '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '" ' . $colors[1] . '>' . $colors[0] . '</a>',
				));
		}
		break;

	case 'topic_details':
		$count = 0;
		foreach( $beer_data as $row )
		{
			if ( !$row['beer_id'] )
			{
				continue;
			}
			$count++;
			$template->assign_block_vars('beersrow', array(
				'ROW_CLASS' => ($count%2) ? 'row1' : 'row2',
				'NO' => intval($count),
				'TOPIC_TITLE' => '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $row['topic_id']) . '" class="topictitle">' . $row['topic_title'] . '</a>',
				'BEERS_COUNT' => $row['beer_count'],
				'PERCENTAGE_BAR' => round($row['beer_count'] / $beer_data['total_beer_count'],2) * 100,
				'POST_LINK' => '<a href="' .append_sid("beermod.$phpEx?mode=post_details&amp;" . POST_POST_URL . "=" . $row['post_id']) . '" class="topictitle">#' . $row['post_id'] . '</a>',
				));
		}
		break;

	default:
		if ( $beer_data_users['total_dst'] && $beer_data_posters['total_src'] )
		{
			$template->assign_block_vars('spacer', array());
		}
		if ( !$beer_data_users['total_dst'] && !$beer_data_posters['total_src'] )
		{
			message_die(GENERAL_ERROR, $lang['Beermod_no_results']);
		}
		if ( $beer_data_users['total_dst'] )
		{
			$template->assign_block_vars('toplist_users', array());
			$count = 0;
			foreach( $beer_data_users as $row )
			{

				if ( $row['user_id'] < 2 || !is_array($row) )
				{
					continue;
				}
				$count++;
				$colors = color_username($row['user_level'], $row['user_jr'], $row['user_id'], $row['username'], true, 'text-decoration:none');
				$template->assign_block_vars('toplist_users.usersrow', array(
					'ROW_CLASS' => ($count%2) ? 'row1' : 'row2',
					'NO' => intval($count),
					'BEERS_DST' => intval($row['user_beers_dst']),
					'BEERS_SRC' => intval($row['user_beers_src']),
					'PERCENTAGE_BAR' => ($beer_data_users['total_dst']) ? round($row['user_beers_dst'] / $beer_data_users['total_dst'],2) * 100 : 0,
					'USERNAME' => '<a href="' . append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '" ' . $colors[1] . '>' . $colors[0] . '</a>',
					));
			}

		}
		if ( $beer_data_posters['total_src'] )
		{
			$template->assign_block_vars('toplist_posters', array());
			$count = 0;
			foreach( $beer_data_posters as $row )
			{

				if ( $row['user_id'] < 2 || !is_array($row) )
				{
					continue;
				}
				$count++;
				$colors = color_username($row['user_level'], $row['user_jr'], $row['user_id'], $row['username'], true, 'text-decoration:none');
				$template->assign_block_vars('toplist_posters.postersrow', array(
					'ROW_CLASS' => ($count%2) ? 'row1' : 'row2',
					'NO' => intval($count),
					'BEERS_DST' => intval($row['user_beers_dst']),
					'BEERS_SRC' => intval($row['user_beers_src']),
					'PERCENTAGE_BAR' => ($beer_data_users['total_dst']) ? round($row['user_beers_src'] / $beer_data_users['total_dst'],2) * 100 : 0,
					'USERNAME' => '<a href="' . append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '" ' . $colors[1] . '>' . $colors[0] . '</a>',
					));
			}
		}

}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
